#!/usr/bin/env python
# -*- Python -*- 


import sys


import threading
import OpenRTM_aist



class Robot_Hard:
  def __init__(self, spos, speed, K, eps, size, sampling_time, target=0):
    self.init(spos, speed, K, eps, size, sampling_time, target)
    self._mutex = threading.RLock()
    self._sim_mutex = threading.RLock()
  def init(self, spos, speed, K, eps, size, sampling_time, target=0):
    self._x = spos
    self._vel = 0
    self._speed = speed
    self._eps = eps
    self._K = K
    self._size = size
    self._target = target
    self._sampling_time = sampling_time

  def get_mutex(self):
    return self._sim_mutex
  def set_mutex(self, v):
    self._sim_mutex = v
  def del_mutex(self):
    self._sim_mutex = 0
  mutex = property(get_mutex, set_mutex, del_mutex)
    
    
  def get_x(self):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    return self._x
  def set_x(self, v):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    self._x = v
  def del_x(self):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    self._x = 0
  x = property(get_x, set_x, del_x)


  def get_vel(self):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    return self._vel
  def set_vel(self, v):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    self._vel = v
  def del_vel(self):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    self._vel = 0
  vel = property(get_vel, set_vel, del_vel)

  def get_target(self):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    return self._target
  def set_target(self, v):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    self._target = v
  def del_target(self):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    self._target = 0

  target = property(get_target, set_target, del_target)
  

class Box:
  def __init__(self, spos, size):
    self.init(spos, size)
    self._mutex = threading.RLock()
    self._sim_mutex = threading.RLock()

  def init(self, spos, size):
    self._x = spos
    self._vel = 0
    self._size = size
    
  def get_mutex(self):
    return self._sim_mutex
  def set_mutex(self, v):
    self._sim_mutex = v
  def del_mutex(self):
    self._sim_mutex = 0
  mutex = property(get_mutex, set_mutex, del_mutex)
  
  def get_x(self):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    return self._x
  def set_x(self, v):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    self._x = v
  def del_x(self):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    self._x = 0
  x = property(get_x, set_x, del_x)


  def get_vel(self):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    return self._vel
  def set_vel(self, v):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    self._vel = v
  def del_vel(self):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    self._vel = 0
  vel = property(get_vel, set_vel, del_vel)







  def get_size(self):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    return self._size
  def set_size(self, v):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    self._size = v
  def del_size(self):
    guard = OpenRTM_aist.ScopedLock(self._mutex)
    self._size = 0
  size = property(get_size, set_size, del_size)